Bug 582068 - (CVE-2010-1488) CVE-2010-1488 kernel: oom: fix the unsafe usage of badness() in proc_oom_score()
CVE-2010-1488 kernel: oom: fix the unsafe usage of badness() in proc_oom_score()
Status: CLOSED NOTABUG
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
high Severity high
: ---
: ---
Assigned To: Red Hat Product Security
: Security
Depends On: 579408 582069
Blocks:
  Show dependency treegraph
 
Reported: 2010-04-13 22:07 EDT by Eugene Teo (Security Response)
Modified: 2013-07-23 18:16 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-07-23 18:16:52 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Eugene Teo (Security Response) 2010-04-13 22:07:28 EDT
Description of problem:
proc_oom_score(task) has a reference to task_struct, but that is all. If this task was already released before we take tasklist_lock
    
- we can't use task->group_leader, it points to nowhere
    
- it is not safe to call badness() even if this task is ->group_leader, has_intersects_mems_allowed() assumes it is safe to iterate over ->thread_group list.
    
- even worse, badness() can hit ->signal == NULL
    
Add the pid_alive() check to ensure __unhash_process() was not called.
    
Also, use "task" instead of task->group_leader. badness() should return the same result for any sub-thread. Currently this is not true, but this should be changed anyway.

Upstream commit:
http://git.kernel.org/linus/b95c35e76b29ba812e5dabdd91592e25ec640e93
Comment 1 Eugene Teo (Security Response) 2010-04-13 22:09:27 EDT
Statement:

Not vulnerable. The Linux kernel as shipped with with Red Hat Enterprise Linux 3, 4, 5 and Red Hat Enterprise MRG did not include upstream commit 28b83c51 (v2.6.32-rc1) that introduced the problem.
Comment 4 Vincent Danen 2010-04-20 18:43:14 EDT
This has been assigned CVE-2010-1488

Note You need to log in before you can comment on or make changes to this bug.